Subject: Re: bug#55227: [PATCH core-updates 0/8] The Full Source Bootstrap

From: Jan Nieuwenhuizen <[email-masked]>
Date: Fri, 13 May 2022 10:07:45 +0200

Ludovic Courtès writes:

Hello!

> "Jan (janneke) Nieuwenhuizen" <[email-masked]> skribis:
>
>> About a year ago we cheered something like:  WE DID IT!!!
>>
>> Today I am very excited to finally have released GNU Mes 0.24 which supports
>> the Full Source Bootstrap.  So we did what?  As Carl Dong once so eloquently
>> put it
>>
>>    The holy grail of bootstrappability will be connecting mes to hex0
>>
>> which is exactly what this patch series brings.
>
> Woohoo!!  Truly amazing.  I just can’t believe it’s become a reality!

My thoughts exactly, and very nice to hear you say it too!

>> Starting from an 357-byte hex0 provided by the new bootstrap-seeds package,
>> the new stage0-posix package builds hex0, kaem, hex1, catm, hex2, M0, cc_x86,
>> M1, M2, get_machine, (mescc-tools), and M2-Planet.  The 0.24 release of Mes
>> can now be built using this M2-Planet.
>>
>> This means that the bootstrap binaries that were added as part of the Reduced
>> Binary Seed Bootstrap (see
>> https://guix.gnu.org/blog/2020/guix-further-reduces-bootstrap-seed-to-25):
>> %bootstrap-mescc-tools, %bootstrap-mes, are now removed again.
>
> Yay!  (And we’ll need a new blog post once that’s merged!)

Sure!

> I haven’t checked but if you confirm that ‘guix build coreutils’ or
> similar passes

Re-confirming this now, "already" up to...

    building /gnu/store/1kj9y2qkd7nc7jhyfa0ywqkbmbv4a8ki-gcc-mesboot-4.9.4.drv...

> (and that the output of ‘guix build coreutils -s powerpc64le -d’, for
> example, is unaffected),

Ah that's a nice trick.  No changes!

    $ ./pre-inst-env guix build coreutils -s powerpc64le-linux -d
    /gnu/store/rsg7k7rih8giz2a3gbd281ygzixzg5yn-coreutils-8.32.drv

> this can go on ‘core-updates’.

OK.  I have reset wip-full-source-bootstrap and will send a v3 patch
series.  We probably want to think about/change the actual mirror spell
"mirror://gnu/guix/mirror/" (?) to use (see other mails).

> Please add “gnu:” as a prefix to the commit log of patches that modify
> gnu/packages/*.

Done.

>>  4 files changed, 315 insertions(+), 308 deletions(-)
>
> And on top of that, it comes almost for free in terms of lines of code
> on our side.  :-)

Yeah, what a bonus.  The thing is that stage0-posix includes mescc-tools
and m2-planet; we were expecting at least two extra packages...

> One last thing: *thank you*.  Thank you for bringing it to completion,
> for never giving up in the face of a mountain of challenges of all
> sorts; thank you for inspiring us!

Thats really great to hear, it means a lot to me.  I'm very grateful for
all your support in this journey and for Guix, that presented me with a
beautiful piece of code to play with and prototype the bootstraps.  And
also, many thanks for the opportunity to stepwise introduce these
changes.  Time to start thinking about the next big step for
bootstrappable!

Greetings,
Janneke

-- 
Jan Nieuwenhuizen <[email-masked]>  | GNU LilyPond https://lilypond.org
Freelance IT https://JoyOfSource.com | Avatar® https://AvatarAcademy.com